<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>G-CTMQC: coherence_corrections Module Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">G-CTMQC
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('namespacecoherence__corrections.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions/Subroutines</a>  </div>
  <div class="headertitle">
<div class="title">coherence_corrections Module Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Calculations of quantities for decoherence corrections in CT-MQC.  
<a href="namespacecoherence__corrections.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions/Subroutines</h2></td></tr>
<tr class="memitem:af2109e0117f30acd569e33fc9642148f"><td class="memItemLeft" align="right" valign="top">subroutine&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecoherence__corrections.html#af2109e0117f30acd569e33fc9642148f">accumulated_boforce</a> (coeff, force, trajlabel)</td></tr>
<tr class="memdesc:af2109e0117f30acd569e33fc9642148f"><td class="mdescLeft">&#160;</td><td class="mdescRight">The adiabatic (or spin-(a)diabatic) force is integrated in time along a trajectory.  <a href="namespacecoherence__corrections.html#af2109e0117f30acd569e33fc9642148f">More...</a><br /></td></tr>
<tr class="separator:af2109e0117f30acd569e33fc9642148f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a982938b35739c7630cfcd56808b3882c"><td class="memItemLeft" align="right" valign="top">subroutine&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecoherence__corrections.html#a982938b35739c7630cfcd56808b3882c">quantum_momentum</a> (Rcl, acc_force, BOsigma, k_li)</td></tr>
<tr class="memdesc:a982938b35739c7630cfcd56808b3882c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculation of the quantum momentum by reconstructing the nuclear density as a sum of Gaussians centered at the positions of the trajectories.  <a href="namespacecoherence__corrections.html#a982938b35739c7630cfcd56808b3882c">More...</a><br /></td></tr>
<tr class="separator:a982938b35739c7630cfcd56808b3882c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Calculations of quantities for decoherence corrections in CT-MQC. </p>
<dl class="section author"><dt>Author</dt><dd>Federica Agostini, Institut de Chimie Physique, University Paris-Saclay. </dd></dl>
</div><h2 class="groupheader">Function/Subroutine Documentation</h2>
<a id="af2109e0117f30acd569e33fc9642148f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af2109e0117f30acd569e33fc9642148f">&#9670;&nbsp;</a></span>accumulated_boforce()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine coherence_corrections::accumulated_boforce </td>
          <td>(</td>
          <td class="paramtype">complex(kind=qp), dimension(nstates), intent(in)&#160;</td>
          <td class="paramname"><em>coeff</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(n_dof,nstates), intent(inout)&#160;</td>
          <td class="paramname"><em>force</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer, intent(in)&#160;</td>
          <td class="paramname"><em>trajlabel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The adiabatic (or spin-(a)diabatic) force is integrated in time along a trajectory. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">trajlabel</td><td>label of the trajectory along which the equation is integrated </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">coeff</td><td>electronic coefficientes </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">force</td><td>integrated force along the trajectory </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">i</td><td>integer index </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">i_dof</td><td>index running on the n_dof degrees of freedom </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">check</td><td>control variable for allocation errors </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">threshold</td><td>electronic population threshold to accumate the force </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">mean_force</td><td>average electronic force weighted by the electronic population </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The value of the adiabatic (or spin-(a)diabatic) force is returned if the electronic population of the corresponding state is larger than threshold and smaller that one minus the threshold. </dd></dl>

<p class="definition">Definition at line <a class="el" href="coherence__corrections_8f90_source.html#l00050">50</a> of file <a class="el" href="coherence__corrections_8f90_source.html">coherence_corrections.f90</a>.</p>

</div>
</div>
<a id="a982938b35739c7630cfcd56808b3882c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a982938b35739c7630cfcd56808b3882c">&#9670;&nbsp;</a></span>quantum_momentum()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine coherence_corrections::quantum_momentum </td>
          <td>(</td>
          <td class="paramtype">real(kind=dp), dimension(ntraj,n_dof), intent(in)&#160;</td>
          <td class="paramname"><em>Rcl</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(ntraj,n_dof,nstates), intent(in)&#160;</td>
          <td class="paramname"><em>acc_force</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">complex(kind=qp), dimension(ntraj,nstates,nstates), intent(in)&#160;</td>
          <td class="paramname"><em>BOsigma</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(ntraj,nstates,nstates), intent(inout)&#160;</td>
          <td class="paramname"><em>k_li</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculation of the quantum momentum by reconstructing the nuclear density as a sum of Gaussians centered at the positions of the trajectories. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">BOsigma</td><td>electronic density matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">Rcl</td><td>positions of the trajectories </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">acc_force</td><td>force accumulated along the trajectory </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">k_li</td><td>term accounting for decoherence effects in CT-MQC </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">itraj,jtraj</td><td>indices running on the Ntraj trajectories </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">i_dof</td><td>index running on the n_dof degrees of freedom </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">index_ij</td><td>index running on the pairs of electronic states </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">istate,jstate</td><td>indices running on the electronic states </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">gamma</td><td>variances of the Gaussians centered at the positions of the trajectories and used to reconstruct the nuclear density </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">g_i</td><td>sum of Gaussians </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">prod_g_i</td><td>product of one-dimensional Gaussians to construct a multi-dimensional Gaussian </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">w_ij</td><td>see paper DOI:... </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">slope_i</td><td>slope of the quantum momentum when it is approximated as a linear function </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">ratio</td><td>y-intercept when the quantum momentum is approximated as a linear function </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">num_old</td><td>numerator in the expression of the y-intercept to approximate the quantum momentum as a linear function when the condition of no-population-transfer between two electronic states is imposed for zero values of the non-adiabatic couplings </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">num_new</td><td>numerator in the analytical expression of the y-intercept to approximate the quantum momentum as a linear function </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">num</td><td>numerator in the expression of the y-intercept of the linear quantum momentum </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">denom</td><td>denominator in the expression of the y-intercept of the linear quantum momentum </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">qmom</td><td>quantum momentum </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">threshold</td><td>for the selection of the num_old or num_old (M_parameter * threshold is the applied distance criterion) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The value of k_li is returned. </dd></dl>

<p class="definition">Definition at line <a class="el" href="coherence__corrections_8f90_source.html#l00132">132</a> of file <a class="el" href="coherence__corrections_8f90_source.html">coherence_corrections.f90</a>.</p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacecoherence__corrections.html">coherence_corrections</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
